$(document).ready(function() {
    checkConnectivity(true);
    //Verify Hypersign connectivity every 60 seconds.
    // setInterval(function() {checkConnectivity(false)}, ONCE_A_MINUTE_INTERVAL);
});

var failedAttempts = 0;
var FAILED_ATTEMPT_THRESHOLD = 10;

function checkConnectivity(forceShowErrorMessage) {
    var connectionSuccessful = false;

    //First verify that we can connect to hypersign.
    $.ajax({url: baseUrl + "status/ping",
        type: 'GET',
        cache: false,
        timeout: 3000,
        crossDomain: true,
        statusCode: {
            200: function () {
                connectionSuccessful = true;
            },
            0: function () {
                connectionSuccessful = false;
            }
        },
        complete: function() {
            var showErrorMessage = false;
            var dismissErrorMessage = false;

            if (!connectionSuccessful) {
                logMessage("Unable to connect to Hypersign server.", LOG_TYPE_CONNECTION_ERROR);
                failedAttempts++;
                //If we've had 10 or more failures, show the error message.
                console.log("Force show " + forceShowErrorMessage);
                if((forceShowErrorMessage === true || failedAttempts >= FAILED_ATTEMPT_THRESHOLD) && $("#connectionErrorContainer").length == 0) {
                    showErrorMessage = true;
                }
            //If we had a successful attempt, reset the failure count.
            } else {
                //If we've already had one successful attempt prior to this one, make sure we dismiss the error message.
                if (failedAttempts == 0) {
                    dismissErrorMessage = true;
                }
                failedAttempts = 0;
            }

            if (showErrorMessage) {
                showConnectionErrorMessage();
            } else {
                if (dismissErrorMessage && $("#connectionErrorContainer").length) {
                    logMessage("Connection to Hypersign restored.", LOG_TYPE_CONNECTION_RESTORED);
                    $("#connectionErrorContainer").remove();
                    initialize();
                }
            }
        }
    });
}

function showConnectionErrorMessage() {
    logMessage("Showing connection error message.", LOG_TYPE_SHOW_CONNECTION_ERROR_MESSAGE);

    $("body").append('<div id="connectionErrorContainer" class="errorContainer">' +
    '<div id="connectionError" class="col-md-12">' +
    'Unable to connect. Please check your internet connection.<br/>' +
    '<button id="runSelfTest" class="btn btn-success">Run Self Test</button>' +
    '<button id="restart" class="btn btn-warning">Restart</button>' +
    '</div>' +
    '</div>');

    $("#runSelfTest").bind("click", function () {
        chrome.app.window.create('selfTest.html', {state: 'fullscreen'});
    });

    $("#restart").bind("click", function () {
        // chrome.runtime.restart();
        chrome.runtime.reload();
    });
}