$(document).ready(function() {
    $("#close").bind("click", function() {
        chrome.app.window.current().close();
    });
    $("#btnStartSpeedTest").bind("click", function() {
        startSpeedTest();
    });
    $("#btnRunConnectionTests").bind("click", function() {
        runSelfTest();
    });
    runSelfTest();
});

function startSpeedTest() {
    logMessage("Initiating speed test", LOG_TYPE_SPEED_TEST_START);
    var webview = '<webview src="' + baseUrl + 'status/speedTest/" style="padding:0;margin:0;height:500px;width:100%;border:2px solid black;outline:none;"></webview>';
    $("#speedTestResults").html(webview);
}

function setConnectionStatus(params, status) {
    var cell = $("#" + params.id);
    cell.html(status);
    if (status == "Success") {
        cell.parent("tr").addClass("success");
    } else {
        cell.parent("tr").addClass("danger");
    }

    if (id == "hypersign") {
        if (status != "Success") {
            $("#btnStartSpeedTest").prop("disabled", true);
        } else {
            $("#btnStartSpeedTest").prop("disabled", false);
        }
    }
}

function clearTestResults() {
    clearTestResult("hypersign");
    clearTestResult("youtube");
    clearTestResult("picasa");
}

function clearTestResult(id) {
    var cell = $("#" + id);
    cell.html("");
    cell.parent("tr").removeClass("success").removeClass("danger");
}

function runSelfTest() {
    clearTestResults();
    testConnectivity(baseUrl + "status/ping", {id: "hypersign"}, setConnectionStatus);
    testConnectivity("http://www.youtube.com/", {id: "youtube"}, setConnectionStatus);
    testConnectivity("http://picasa.google.com/", {id: "picasa"}, setConnectionStatus);
}