$(window).load(function() {
    //Test connections ever hour.
    setInterval(testConnections, ONCE_AN_HOUR_INTERVAL);

    //Truncate logs once a day.
    setInterval(function() {truncateLog()}, ONCE_A_DAY_INTERVAL);
});

function logMessage(message, type) {
    chrome.runtime.getBackgroundPage(function (bgPage) {
        bgPage.dbApi.indexedDB.logMessage(message, type);
    });
}

function testConnectivity(url, params, callback) {
    var status;
    $.ajax({url: url,
        type: "GET",
        cache: false,
        timeout:3000,
        crossDomain: true,
        statusCode: {
            200: function () {
                status = "Success";
            },
            400: function () {
                status = "Bad Request";
            },
            404: function () {
                status = "Not Found";
            },
            0: function () {
                status = "Failed";
            }
        },
        complete: function() {
            callback(params, status);
        }
    });
}

function testConnections() {
    var url = baseUrl + "status/ping";
    testConnectivity(url, {url: url}, logConnectivityResult);
    url = "http://www.youtube.com/";
    testConnectivity(url, {url: url}, logConnectivityResult);
    url = "http://www.google.com/";
    testConnectivity(url, {url: url}, logConnectivityResult);
}

function logConnectivityResult(params, status) {
    logMessage("Test connection to: " + params.url + ". Status: " + status, "Connection Test");
}

function truncateLog() {
    chrome.runtime.getBackgroundPage(function (bgPage) {
        bgPage.dbApi.indexedDB.truncate();
    });
}